AchievementFocused = class(Turbine.UI.Control)
function AchievementFocused:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.skillList = {
        ["Penetrating Shot"] = true,
        ["Blood Arrow"] = true,
        ["Merciful Shot"] = true,
        ["Improved Merciful Shot"] = true,
        ["Improved Penetrating Shot"] = true,
        ["Barrage"] = true,
        ["Split Shot"] = true,
        ["Explosive Arrow"] = true,
        ["Pinning Shot"] = true,
        ["Upshot"] = true,
        ["Rain of Arrows"] = true,
        ["Rain of Thorns"] = true,
        ["Lingering Wound"] = true,
    }

    self.handler = handler

    self.Command = Turbine.ShellCommand()
    function self.Command:Execute()
        HardcoreHandler:GetAchievementHint("Focused")
    end

    Turbine.Shell.AddCommand("hardcorefocused", self.Command)
    ChatOutput("Use the command /hardcorefocused to see a list of affected skills")

    self:SetCallbacks()
end

function AchievementFocused:SetCallbacks()
    self.skillCallbacks = {}
    for key, value in pairs(SkillEventHandler:GetSkills()) do
        if self.skillList[key] then
            table.insert(self.skillCallbacks, AddCallback(SkillEventHandler, key, function(skill) 
                self.handler:Fail("Focused", "Usage of an illegal skill", 0x41008201)
            end))
        end
    end
end

function AchievementFocused:Unload()
    for key, value in pairs(self.skillCallbacks) do
        RemoveCallback(SkillEventHandler, key, value) 
    end
end

function AchievementFocused:Refresh()
    self:Unload()
    self:SetCallbacks()
end


function AchievementFocused:GetHint()
    ChatOutput("<rgb=#005500>Only non focus spending skills can be used.")
    ChatOutput("<rgb=#FF0000>Skills that are not allowed:")
    for key, value in PrimeUtils.Utils.spairs(self.skillList, function(t, a, b) return a < b end) do
       ChatOutput(key)
    end
end